<?php
namespace Bushelpowered\Api\Payments\V1\Model;
        
class PaymentStandard implements \Bushelpowered\Api\Common\Event\StandardRecord, \Bushelpowered\Api\Common\HasSourceTimestamps, \Bushelpowered\Api\Common\HasTimestamps
{
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceAccountId = null;
    public ?string $accountId = null;
    public ?string $accountIntegrationId = null;
    public ?string $sourceLocationId = null;
    public ?string $locationId = null;
    public ?string $locationIntegrationId = null;
    public ?string $sourceCommodityId = null;
    public ?string $commodityId = null;
    public ?string $commodityIntegrationId = null;
    public string $entityRevisionId;
    /** @var string[]|null $sourceSettlementIds */
    public ?array $sourceSettlementIds = null;
    /** @var string[]|null $sourceInvoiceIds */
    public ?array $sourceInvoiceIds = null;
    public ?string $sourceDisplayId = null;
    public float $sourcePaymentAmount;
    public string $sourcePaymentType;
    public string $sourceStatus;
    /** @var null|string $sourcePaymentDate of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourcePaymentDate = null;
    public ?string $sourceCurrency = null;
    public ?string $sourceComments = null;
    public string $id;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var null|string $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;
    /** @var string $sourceCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceCreatedAt;
    /** @var string $sourceUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceUpdatedAt;
    /** @var null|string $sourceDeletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourceDeletedAt = null;

    /**
     * @param  string[]|null  $sourceSettlementIds 
     * @param  string[]|null  $sourceInvoiceIds 
     * @param  null|string  $sourcePaymentDate of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $sourceCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $sourceUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $sourceDeletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceAccountId, ?string $accountId, ?string $accountIntegrationId, ?string $sourceLocationId, ?string $locationId, ?string $locationIntegrationId, ?string $sourceCommodityId, ?string $commodityId, ?string $commodityIntegrationId, string $entityRevisionId, ?array $sourceSettlementIds, ?array $sourceInvoiceIds, ?string $sourceDisplayId, float $sourcePaymentAmount, string $sourcePaymentType, string $sourceStatus, ?string $sourcePaymentDate, ?string $sourceCurrency, ?string $sourceComments, string $id, string $updatedAt, string $createdAt, ?string $deletedAt, string $sourceCreatedAt, string $sourceUpdatedAt, ?string $sourceDeletedAt)
    {
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceAccountId = $sourceAccountId;
        $this->accountId = $accountId;
        $this->accountIntegrationId = $accountIntegrationId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationId = $locationId;
        $this->locationIntegrationId = $locationIntegrationId;
        $this->sourceCommodityId = $sourceCommodityId;
        $this->commodityId = $commodityId;
        $this->commodityIntegrationId = $commodityIntegrationId;
        $this->entityRevisionId = $entityRevisionId;
        $this->sourceSettlementIds = $sourceSettlementIds;
        $this->sourceInvoiceIds = $sourceInvoiceIds;
        $this->sourceDisplayId = $sourceDisplayId;
        $this->sourcePaymentAmount = $sourcePaymentAmount;
        $this->sourcePaymentType = $sourcePaymentType;
        $this->sourceStatus = $sourceStatus;
        $this->sourcePaymentDate = $sourcePaymentDate;
        $this->sourceCurrency = $sourceCurrency;
        $this->sourceComments = $sourceComments;
        $this->id = $id;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getAccountId(): ?string
    {
        return $this->accountId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getId(): string
    {
        return $this->id;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceCreatedAt(): string
    {
        return $this->sourceCreatedAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceUpdatedAt(): string
    {
        return $this->sourceUpdatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceDeletedAt(): ?string
    {
        return $this->sourceDeletedAt;
    }
}