<?php
namespace Bushelpowered\Api\Platform\Commodity\V1\Request;
        
class GetAllTenantCommoditiesRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string[]|null $ids */
    public ?array $ids = null;
    /** @var string[]|null $tenantIds */
    public ?array $tenantIds = null;
    /** @var string[]|null $datasourceIds */
    public ?array $datasourceIds = null;
    /** @var string[]|null $integrationIds */
    public ?array $integrationIds = null;
    /** @var string[]|null $locationIds */
    public ?array $locationIds = null;
    /** @var string[]|null $commodityIds */
    public ?array $commodityIds = null;
    /** @var string[]|null $commodityGroupIds */
    public ?array $commodityGroupIds = null;
    /** @var string[]|null $commoditySubgroupIds */
    public ?array $commoditySubgroupIds = null;
    /** @var string[]|null $commodityVarietyIds */
    public ?array $commodityVarietyIds = null;
    public ?\Bushelpowered\Api\Platform\Commodity\V1\Request\CommodityPagination $pagination = null;

    /**
     * @param  string[]|null  $ids 
     * @param  string[]|null  $tenantIds 
     * @param  string[]|null  $datasourceIds 
     * @param  string[]|null  $integrationIds 
     * @param  string[]|null  $locationIds 
     * @param  string[]|null  $commodityIds 
     * @param  string[]|null  $commodityGroupIds 
     * @param  string[]|null  $commoditySubgroupIds 
     * @param  string[]|null  $commodityVarietyIds 
     */
    public function __construct(?array $ids, ?array $tenantIds, ?array $datasourceIds, ?array $integrationIds, ?array $locationIds, ?array $commodityIds, ?array $commodityGroupIds, ?array $commoditySubgroupIds, ?array $commodityVarietyIds, ?\Bushelpowered\Api\Platform\Commodity\V1\Request\CommodityPagination $pagination)
    {
        $this->ids = $ids;
        $this->tenantIds = $tenantIds;
        $this->datasourceIds = $datasourceIds;
        $this->integrationIds = $integrationIds;
        $this->locationIds = $locationIds;
        $this->commodityIds = $commodityIds;
        $this->commodityGroupIds = $commodityGroupIds;
        $this->commoditySubgroupIds = $commoditySubgroupIds;
        $this->commodityVarietyIds = $commodityVarietyIds;
        $this->pagination = $pagination;
    }
    
    public function getPagination(): ?\Bushelpowered\Api\Platform\Commodity\V1\Request\CommodityPagination
    {
        return $this->pagination;
    }
}