<?php
namespace Bushelpowered\Api\Platform\Location\V1\Request;
        
class LocationRequest implements \Bushelpowered\Api\Platform\Location\V1\Request\HasLocationType
{
    public ?string $parentId = null;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceName = null;
    public ?string $internalName = null;
    public string $publicName;
    public ?string $physicalAddressLine1 = null;
    public ?string $physicalAddressLine2 = null;
    public ?string $physicalLocality = null;
    public ?string $physicalAdministrativeArea = null;
    public ?string $physicalPostalCode = null;
    public ?string $physicalCountryCode = null;
    public ?float $latitude = null;
    public ?float $longitude = null;
    public ?string $businessPhone = null;
    public ?string $businessFax = null;
    public ?string $businessEmail = null;
    public ?string $businessWebsite = null;

    /**
     */
    public function __construct(?string $parentId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceName, ?string $internalName, string $publicName, ?string $physicalAddressLine1, ?string $physicalAddressLine2, ?string $physicalLocality, ?string $physicalAdministrativeArea, ?string $physicalPostalCode, ?string $physicalCountryCode, ?float $latitude, ?float $longitude, ?string $businessPhone, ?string $businessFax, ?string $businessEmail, ?string $businessWebsite)
    {
        $this->parentId = $parentId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceName = $sourceName;
        $this->internalName = $internalName;
        $this->publicName = $publicName;
        $this->physicalAddressLine1 = $physicalAddressLine1;
        $this->physicalAddressLine2 = $physicalAddressLine2;
        $this->physicalLocality = $physicalLocality;
        $this->physicalAdministrativeArea = $physicalAdministrativeArea;
        $this->physicalPostalCode = $physicalPostalCode;
        $this->physicalCountryCode = $physicalCountryCode;
        $this->latitude = $latitude;
        $this->longitude = $longitude;
        $this->businessPhone = $businessPhone;
        $this->businessFax = $businessFax;
        $this->businessEmail = $businessEmail;
        $this->businessWebsite = $businessWebsite;
    }
    
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getSourceName(): ?string
    {
        return $this->sourceName;
    }
    public function getInternalName(): ?string
    {
        return $this->internalName;
    }
    public function getPublicName(): string
    {
        return $this->publicName;
    }
    public function getPhysicalAddressLine1(): ?string
    {
        return $this->physicalAddressLine1;
    }
    public function getPhysicalAddressLine2(): ?string
    {
        return $this->physicalAddressLine2;
    }
    public function getPhysicalLocality(): ?string
    {
        return $this->physicalLocality;
    }
    public function getPhysicalAdministrativeArea(): ?string
    {
        return $this->physicalAdministrativeArea;
    }
    public function getPhysicalPostalCode(): ?string
    {
        return $this->physicalPostalCode;
    }
    public function getPhysicalCountryCode(): ?string
    {
        return $this->physicalCountryCode;
    }
    public function getLatitude(): ?float
    {
        return $this->latitude;
    }
    public function getLongitude(): ?float
    {
        return $this->longitude;
    }
    public function getBusinessPhone(): ?string
    {
        return $this->businessPhone;
    }
    public function getBusinessFax(): ?string
    {
        return $this->businessFax;
    }
    public function getBusinessEmail(): ?string
    {
        return $this->businessEmail;
    }
    public function getBusinessWebsite(): ?string
    {
        return $this->businessWebsite;
    }
}