<?php
namespace Bushelpowered\Api\Platform\Tenant\V1;

use \Bushelpowered\Api\Platform\Tenant\V1\Request\GetAllDatasourcesRequest;
use \Bushelpowered\Api\Platform\Tenant\V1\Response\DatasourceListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetAllDatasources 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetAllDatasourcesRequest $request, $headers): DatasourceListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/platform/tenant/v1/GetAllDatasources', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetAllDatasourcesRequest $request, GetAllDatasourcesMetadata $hasHeaders): DatasourceListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/platform/tenant/v1/GetAllDatasources', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var DatasourceListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.tenant.v1#GetAllDatasourcesSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\Tenant\V1\Response\DatasourceListResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}